/[MITgcm]/MITgcm/tools/genmake2
ViewVC logotype

Diff of /MITgcm/tools/genmake2

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.39 by edhill, Fri Nov 14 19:01:36 2003 UTC revision 1.66 by edhill, Mon Feb 23 21:51:32 2004 UTC
# Line 1  Line 1 
1  #!/bin/sh  #! /usr/bin/env bash
2  #  #
3  # $Header$  # $Header$
4  #  #
# Line 13  Line 13 
13  test_for_package_in_cpp_options() {  test_for_package_in_cpp_options() {
14      cpp_options=$1      cpp_options=$1
15      pkg=$2      pkg=$2
16      grep -i "#define.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_$pkg" || exit 99
17      RETVAL=$?      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_$pkg" || exit 99
18      if test "x${RETVAL}" = x0 ; then      test_for_string_in_file $cpp_options "^[ ]*#define.*DISABLE_$pkg" || exit 99
19          echo "Error: In $cpp_options there is an illegal line: #define ALLOW_$pkg"      test_for_string_in_file $cpp_options "^[ ]*#undef.*DISABLE_$pkg" || exit 99
20          exit 99  }
21      fi  
22      grep -i "#undef.*ALLOW_$pkg" $cpp_options > /dev/null 2>&1  # Search for particular CPP #cmds associated with MPI
23      RETVAL=$?  # usage: test_for_mpi_in_cpp_eeoptions CPP_file
24      if test "x${RETVAL}" = x0 ; then  test_for_mpi_in_cpp_eeoptions() {
25          echo "Error: In $cpp_options there is an illegal line: #undef ALLOW_$pkg"      cpp_options=$1
26          exit 99      test_for_string_in_file $cpp_options "^[ ]*#define.*ALLOW_USE_MPI" || exit 99
27      fi      test_for_string_in_file $cpp_options "^[ ]*#undef.*ALLOW_USE_MPI" || exit 99
28      grep -i "#define.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      test_for_string_in_file $cpp_options "^[ ]*#define.*ALWAYS_USE_MPI" || exit 99
29        test_for_string_in_file $cpp_options "^[ ]*#undef.*ALWAYS_USE_MPI" || exit 99
30    }
31    
32    # Search for particular string in a file. Return 1 if detected, 0 if not
33    # usage: test_for_string_in_file file string
34    test_for_string_in_file() {
35        file=$1
36        strng=$2
37        grep -i "$strng" $file > /dev/null 2>&1
38      RETVAL=$?      RETVAL=$?
39      if test "x${RETVAL}" = x0 ; then      if test "x${RETVAL}" = x0 ; then
40          echo "Error: In $cpp_options there is an illegal line: #define DISABLE_$pkg"          echo -n "Error: In $file there is an illegal line: "
41          exit 99          grep -i "$strng" $file
42            return 1
43      fi      fi
44      grep -i "#undef.*DISABLE_$pkg" $cpp_options > /dev/null 2>&1      return 0
     RETVAL=$?  
     if test "x${RETVAL}" = x0 ; then  
         echo "Error: In $cpp_options there is an illegal line: #undef DISABLE_$pkg"  
         exit 99  
    fi  
45  }  }
46    
47  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to  # Read the $ROOTDIR/pkg/pkg_groups file and expand any references to
# Line 73  find_possible_configs()  { Line 78  find_possible_configs()  {
78      tmp1=`uname`"_"`uname -m`      tmp1=`uname`"_"`uname -m`
79      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`      tmp2=`echo $tmp1 | sed -e 'y/ABCDEFGHIJKLMNOPQRSTUVWXYZ/abcdefghijklmnopqrstuvwxyz/'`
80      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`      tmp3=`echo $tmp2 | sed -e 's/power macintosh/ppc/'`
81      PLATFORM=`echo $tmp3 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`      tmp1=`echo $tmp3 | sed -e 's|x86_64|amd64|'`
82        tmp2=`echo $tmp1 | sed -e 's/i[3-6]86/ia32/' | sed -e 's/athlon/ia32/'`
83        PLATFORM=$tmp2
84      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`      OFLIST=`(cd $ROOTDIR/tools/build_options; ls | grep "^$PLATFORM")`
85      echo "  The platform appears to be:  $PLATFORM"      echo "  The platform appears to be:  $PLATFORM"
 #     if test "x$OFLIST" = x ; then  
 #       echo "  No pre-defined options files were found matching this platform"  
 #       echo "  but examples for other platforms can be found in:"  
 #       echo "    $ROOTDIR/tools/build_options"  
 #     else  
 #       echo "  Options files (located in $ROOTDIR/tools/build_options) that"  
 #       echo "  may work with this machine are:"  
 #       for i in $OFLIST ; do  
 #           echo "    $i"  
 #       done  
 #     fi  
86            
87      echo "test" > test      echo "test" > test
88      ln -s ./test link      ln -s ./test link
# Line 225  get_pdepend_list()  { Line 221  get_pdepend_list()  {
221    
222  #  Explain usage  #  Explain usage
223  usage()  {  usage()  {
224      echo  cat <<EOF
225      echo "Usage: "$0" [OPTIONS]"  
226      echo "  where [OPTIONS] can be:"  Usage: "$0" [OPTIONS]
227      echo    where [OPTIONS] can be:
228      echo "    -help | --help | -h | --h"  
229      echo "    -nooptfile | --nooptfile"      -help | --help | -h | --h
230      echo "      -optfile NAME | --optfile NAME | -of NAME | --of NAME"            Print this help message and exit.
231      echo "      -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME"  
232      echo "    -pdepend NAME | --pdepend NAME"      -nooptfile | --nooptfile
233      echo "      -pdepend=NAME | --pdepend=NAME"        -optfile NAME | --optfile NAME | -of NAME | --of NAME
234      echo "    -pdefault NAME | --pdefault NAME"        -optfile=NAME | --optfile=NAME | -of=NAME | --of=NAME
235      echo "      -pdefault=NAME | --pdefault=NAME"            Use "NAME" as the optfile.  By default, an attempt will be
236      echo "    -make NAME | -m NAME"            made to find an appropriate "standard" optfile in the
237      echo "      --make=NAME | -m=NAME"            tools/build_options/ directory.
238      echo "    -makefile NAME | -mf NAME"  
239      echo "      --makefile=NAME | -mf=NAME"      -pdepend NAME | --pdepend NAME
240      echo "    -platform NAME | --platform NAME | -pl NAME | --pl NAME"        -pdepend=NAME | --pdepend=NAME
241      echo "      -platform=NAME | --platform=NAME | -pl=NAME | --pl=NAME"            Get package dependency information from "NAME".
242      echo "    -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME"  
243      echo "      -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME"      -pdefault NAME | --pdefault NAME
244      echo "    -mods NAME | --mods NAME | -mo NAME | --mo NAME"        -pdefault=NAME | --pdefault=NAME
245      echo "      -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME"            Get the default package list from "NAME".
246      echo "    -disable NAME | --disable NAME"  
247      echo "      -disable=NAME | --disable=NAME"      -make NAME | -m NAME
248      echo "    -enable NAME | --enable NAME"        --make=NAME | -m=NAME
249      echo "      -enable=NAME | --enable=NAME"            Use "NAME" for the MAKE program. The default is "make" but
250      echo "    -standarddirs NAME | --standarddirs NAME"            many platforms, "gmake" is the preferred choice.
251      echo "      -standarddirs=NAME | --standarddirs=NAME"  
252      echo "    -noopt NAME | --noopt NAME"      -makefile NAME | -mf NAME
253      echo "      -noopt=NAME | --noopt=NAME"        --makefile=NAME | -mf=NAME
254  #    echo "    -cpp NAME | --cpp NAME"            Call the makefile "NAME".  The default is "Makefile".
255  #    echo "      -cpp=NAME | --cpp=NAME"  
256      echo "    -fortran NAME | --fortran NAME | -fc NAME | --fc NAME"      -rootdir NAME | --rootdir NAME | -rd NAME | --rd NAME
257      echo "      -fc=NAME | --fc=NAME"        -rootdir=NAME | --rootdir=NAME | -rd=NAME | --rd=NAME
258      echo "    -[no]ieee | --[no]ieee"            Specify the location of the MITgcm ROOTDIR as "NAME".
259      echo "    -[no]mpi | --[no]mpi"            By default, genamke will try to find the location by
260      echo "    -[no]jam | --[no]jam"            looking in parent directories (up to the 5th parent).
261      echo  
262      echo "  and NAME is a string such as:"      -mods NAME | --mods NAME | -mo NAME | --mo NAME
263      echo        -mods=NAME | --mods=NAME | -mo=NAME | --mo=NAME
264      echo "    --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'"            Here, "NAME" specifies a list of directories that are
265      echo "    -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'"            used for additional source code.  Files found in the
266      echo "    -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'"            "mods list" are given preference over files of the same
267      echo            name found elsewhere.
268      echo "  which, depending upon your shell, may need to be single-quoted"  
269      echo "  if it contains spaces, dashes, or other special characters."      -disable NAME | --disable NAME
270          -disable=NAME | --disable=NAME
271              Here "NAME" specifies a list of packages that we don't
272              want to use.  If this violates package dependencies,
273              genamke will exit with an error message.
274    
275        -enable NAME | --enable NAME
276          -enable=NAME | --enable=NAME
277              Here "NAME" specifies a list of packages that we wish
278              to specifically enable.  If this violates package
279              dependencies, genamke will exit with an error message.
280    
281        -standarddirs NAME | --standarddirs NAME
282          -standarddirs=NAME | --standarddirs=NAME
283              Here, "NAME" specifies a list of directories to be
284              used as the "standard" code.
285    
286        -fortran NAME | --fortran NAME | -fc NAME | --fc NAME
287          -fc=NAME | --fc=NAME
288              Use "NAME" as the fortran compiler.  By default, genmake
289              will search for a working compiler by trying a list of
290              "usual suspects" such as g77, f77, etc.
291    
292        -[no]ieee | --[no]ieee
293              Do or don't use IEEE numerics.  Note that this option
294              *only* works if it is supported by the OPTFILE that
295              is being used.
296    
297      While it is most often a single word, the "NAME" variables specified
298      above can in many cases be a space-delimited string such as:
299    
300        --enable pkg1   --enable 'pkg1 pkg2'   --enable 'pkg1 pkg2 pkg3'
301        -mods=dir1   -mods='dir1'   -mods='dir1 dir2 dir3'
302        -foptim='-Mvect=cachesize:512000,transform -xtypemap=real:64,double:64,integer:32'
303    
304      which, depending upon your shell, may need to be single-quoted.
305    
306      For more detailed genmake documentation, please see:
307    
308        http://mitgcm.org/devel_HOWTO/
309    
310    EOF
311    
312      exit 1      exit 1
313  }  }
314    
# Line 293  WARNING: Please contact <MITgcm-support@ Line 331  WARNING: Please contact <MITgcm-support@
331  EOF  EOF
332          return 1          return 1
333      fi      fi
334      c_tcall=`nm genmake_test.o | grep tcall | cut -d ' ' -f 3`      c_tcall=`nm genmake_test.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
335      RETVAL=$?      RETVAL=$?
336      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
337          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 323  WARNING: Please contact <MITgcm-support@ Line 361  WARNING: Please contact <MITgcm-support@
361  EOF  EOF
362          return 1          return 1
363      fi      fi
364      f_tcall=`nm genmake_tcomp.o | grep tcall | cut -d ' ' -f 3`      f_tcall=`nm genmake_tcomp.o | grep 'T ' | grep tcall | cut -d ' ' -f 3`
365      RETVAL=$?      RETVAL=$?
366      if test "x$RETVAL" != x0 ; then      if test "x$RETVAL" != x0 ; then
367          FC_NAMEMANGLE=$default_nm          FC_NAMEMANGLE=$default_nm
# Line 399  EOF Line 437  EOF
437  }  }
438    
439    
440    check_netcdf_libs()  {
441        cat <<EOF > genmake_tnc.F
442          program fgennc
443    #include "netcdf.inc"
444          integer iret, ncid, xid
445          iret = nf_create('genmake_tnc.nc', NF_CLOBBER, ncid)
446          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
447          iret = nf_def_dim(ncid, 'X', 11, xid)
448          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
449          iret = nf_close(ncid)
450          IF (iret .NE. NF_NOERR) write(*,*) NF_STRERROR(iret)
451          end
452    EOF
453        $CPP genmake_tnc.F > genmake_tnc.f  \
454            &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f $LIBS >> genmake_tnc.log 2>&1
455        RET_COMPILE=$?
456        test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
457        RETVAL=$?
458        if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
459            HAVE_NETCDF=t
460        else
461            # try again with "-lnetcdf" added to the libs
462            $CPP genmake_tnc.F > genmake_tnc.f  \
463                &&  $FC $FFLAGS $FOPTIM -o genmake_tnc genmake_tnc.f \
464                $LIBS -lnetcdf >> genmake_tnc_2.log 2>&1
465            RET_COMPILE=$?
466            test -x ./genmake_tnc  &&  ./genmake_tnc >> genmake_tnc.log 2>&1
467            RETVAL=$?
468            if test "x$RET_COMPILE" = x0 -a "x$RETVAL" = x0 ; then
469                LIBS="$LIBS -lnetcdf"
470                HAVE_NETCDF=t
471            else
472                cat genmake_tnc.log >> genmake_warnings
473            fi
474        fi
475        rm -f genmake_tnc*
476    }
477    
478    
479  #  Set defaults here  #  Set defaults here
480  COMMANDL="$0 $@"  COMMANDL="$0 $@"
481    
# Line 407  LN= Line 484  LN=
484  S64=  S64=
485  KPP=  KPP=
486  FC=  FC=
487    CPP=
488  LINK=  LINK=
489  # DEFINES="-DWORDLENGTH=4"  # DEFINES="-DWORDLENGTH=4"
490  DEFINES=  DEFINES=
# Line 435  HAVE_SYSTEM= Line 513  HAVE_SYSTEM=
513  HAVE_FDATE=  HAVE_FDATE=
514  FC_NAMEMANGLE=  FC_NAMEMANGLE=
515  HAVE_CLOC=  HAVE_CLOC=
516    HAVE_NETCDF=
517    
518  MODS=  MODS=
519  TOOLSDIR=  TOOLSDIR=
520  SOURCEDIRS=  SOURCEDIRS=
521  INCLUDEDIRS=  INCLUDEDIRS=
522  STANDARDDIRS=  STANDARDDIRS="USE_THE_DEFAULT"
523    
524  PWD=`pwd`  PWD=`pwd`
525  MAKE=make  MAKE=make
# Line 473  TAMC_EXTRA= Line 552  TAMC_EXTRA=
552    
553    
554  #  The following state can be set directly by command-line switches  #  The following state can be set directly by command-line switches
555  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE NOOPT"  gm_s1="OPTFILE PDEPEND PDEFAULT MAKEFILE PLATFORM ROOTDIR MODS DISABLE ENABLE"
556  gm_s2="FC IEEE MPI JAM DUMPSTATE STANDARDDIRS"  gm_s2="FC CPP IEEE MPI JAM DUMPSTATE STANDARDDIRS"
557    
558  #  The following state is not directly set by command-line switches  #  The following state is not directly set by command-line switches
559  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "  gm_s3="LN S64 KPP LINK PACKAGES MAKEDEPEND PDEPEND PDEFAULT INCLUDES FFLAGS FOPTIM "
# Line 491  gm_s12="TAF_EXTRA TAMC_EXTRA" Line 570  gm_s12="TAF_EXTRA TAMC_EXTRA"
570  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"  gm_state="COMMANDL $gm_s1 $gm_s2 $gm_s3 $gm_s4 $gm_s5 $gm_s6 $gm_s7"
571  gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"  gm_state="$gm_state $gm_s10 $gm_s11 $gm_s12"
572    
573    cat <<EOF
574    
575    GENMAKE :
576    
577    A program for GENerating MAKEfiles for the MITgcm project.  For a
578    quick list of options, use "genmake -h" or for more detail see:
579    
580      http://mitgcm.org/devel_HOWTO/
581    
582    EOF
583    
 echo  
584  echo "===  Processing options files and arguments  ==="  echo "===  Processing options files and arguments  ==="
585  gm_local="genmake_local"  gm_local="genmake_local"
586  for i in . $MODS ; do  for i in . $MODS ; do
# Line 546  for ac_option ; do Line 634  for ac_option ; do
634          -optfile=* | --optfile=* | -of=* | --of=*)          -optfile=* | --optfile=* | -of=* | --of=*)
635              OPTFILE=$ac_optarg ;;              OPTFILE=$ac_optarg ;;
636                    
637          -adoptfile | --adoptfile | -ad | --ad)          -adoptfile | --adoptfile | -adof | --adof)
638              ac_prev=AD_OPTFILE ;;              ac_prev=AD_OPTFILE ;;
639          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)          -adoptfile=* | --adoptfile=* | -adof=* | --adof=*)
640              AD_OPTFILE=$ac_optarg ;;              AD_OPTFILE=$ac_optarg ;;
# Line 571  for ac_option ; do Line 659  for ac_option ; do
659          -makefile=* | --makefile=* | -ma=* | --ma=*)          -makefile=* | --makefile=* | -ma=* | --ma=*)
660              MAKEFILE=$ac_optarg ;;              MAKEFILE=$ac_optarg ;;
661                    
662          -platform | --platform | -pl | --pl)          -platform | --platform | -pl | --pl | -platform=* | --platform=* | -pl=* | --pl=*)
663              ac_prev=PLATFORM ;;              echo "ERROR: The platform option has been removed.  Please specify"
664          -platform=* | --platform=* | -pl=* | --pl=*)              echo "  the build options using the \"optfile\" mechanism."
665              PLATFORM=$ac_optarg ;;              echo
666                usage
667                ;;
668                    
669          -rootdir | --rootdir | -rd | --rd)          -rootdir | --rootdir | -rd | --rd)
670              ac_prev=ROOTDIR ;;              ac_prev=ROOTDIR ;;
# Line 601  for ac_option ; do Line 691  for ac_option ; do
691          -standarddirs=* | --standarddirs=*)          -standarddirs=* | --standarddirs=*)
692              STANDARDDIRS=$ac_optarg ;;              STANDARDDIRS=$ac_optarg ;;
693    
         -noopt | --noopt)  
             ac_prev=NOOPT ;;  
         -noopt=* | --noopt=*)  
             NOOPT=$ac_optarg ;;  
           
694  #           -cpp | --cpp)  #           -cpp | --cpp)
695  #               ac_prev=cpp ;;  #               ac_prev=cpp ;;
696  #           -cpp=* | --cpp=*)  #           -cpp=* | --cpp=*)
# Line 621  for ac_option ; do Line 706  for ac_option ; do
706          -noieee | --noieee)          -noieee | --noieee)
707              IEEE= ;;              IEEE= ;;
708                    
709          -mpi | --mpi)  #       -jam | --jam)
710              MPI=true ;;  #           JAM=1 ;;
711          -nompi | --nompi)  #       -nojam | --nojam)
712              MPI= ;;  #           JAM=0 ;;
           
         -jam | --jam)  
             JAM=1 ;;  
         -nojam | --nojam)  
             JAM=0 ;;  
713                    
714          -ds | --ds)          -ds | --ds)
715              DUMPSTATE=t ;;              DUMPSTATE=t ;;
# Line 766  fi Line 846  fi
846  if test "x$LINK" = x ; then  if test "x$LINK" = x ; then
847      LINK=$FC      LINK=$FC
848  fi  fi
 if test "x$CPP" = x ; then  
     CPP="cpp"  
 fi  
849  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
850      MAKE="make"      MAKE="make"
851  fi  fi
852    if test "x$CPP" = x ; then
853        CPP=cpp
854    fi
855    #EH3 === UGLY ===
856    #  The following an ugly little hack to check for $CPP in /lib/ and it
857    #  should eventually be replaced with a more general function that
858    #  searches a combo of the user's path and a list of "usual suspects"
859    #  to find the correct location for binaries such as $CPP.
860    for i in " " "/lib/" ; do
861        echo "#define A a" | $i$CPP > test_cpp 2>&1 && CPP=$i$CPP
862    done
863    #EH3 === UGLY ===
864  echo "#define A a" | $CPP > test_cpp 2>&1  echo "#define A a" | $CPP > test_cpp 2>&1
865  RETVAL=$?  RETVAL=$?
866  if test "x$RETVAL" != x0 ; then  if test "x$RETVAL" != x0 ; then
# Line 856  if test "x$HAVE_CLOC" != x ; then Line 945  if test "x$HAVE_CLOC" != x ; then
945  else  else
946      echo "no"      echo "no"
947  fi  fi
 echo "$FC_NAMEMANGLE" > FC_NAMEMANGLE.h.template  
 cmp FC_NAMEMANGLE.h FC_NAMEMANGLE.h.template > /dev/null 2>&1  
 RETVAL=$?  
 if test "x$RETVAL" != x0 ; then  
     mv -f FC_NAMEMANGLE.h.template FC_NAMEMANGLE.h  
 fi  
948  rm -f genmake_t*  rm -f genmake_t*
949    
950    echo -n "  Can we create NetCDF-enabled binaries...  "
951    check_netcdf_libs
952    if test "x$HAVE_NETCDF" != x ; then
953        echo "yes"
954    else
955        echo "no"
956    fi
957    
958    
959  printf "\n===  Setting defaults  ===\n"  printf "\n===  Setting defaults  ===\n"
960  echo -n "  Adding MODS directories:  "  echo -n "  Adding MODS directories:  "
# Line 903  if test "x${TOOLSDIR}" = x ; then Line 994  if test "x${TOOLSDIR}" = x ; then
994      TOOLSDIR="$ROOTDIR/tools"      TOOLSDIR="$ROOTDIR/tools"
995  fi  fi
996  if test ! -d ${TOOLSDIR} ; then  if test ! -d ${TOOLSDIR} ; then
997      echo "Error: the specified $TOOLSDIR (\"$TOOLSDIR\") does not exist!"      echo "Error: the specified TOOLSDIR (\"$TOOLSDIR\") does not exist!"
998      exit 1      exit 1
999  fi  fi
1000  if test "x$S64" = x ; then  if test "x$S64" = x ; then
1001      S64='$(TOOLSDIR)/set64bitConst.sh'      S64='$(TOOLSDIR)/set64bitConst.sh'
1002  fi  fi
1003    THIS_SCRIPT=`echo ${0} | sed 's:'$TOOLSDIR':\$(TOOLSDIR):'`
1004    
1005  EXECUTABLE=${EXECUTABLE:-mitgcmuv}  EXECUTABLE=${EXECUTABLE:-mitgcmuv}
1006    
# Line 923  if test -r $ROOTDIR"/eesupp/src/Makefile Line 1015  if test -r $ROOTDIR"/eesupp/src/Makefile
1015          rm -f make_eesupp.errors          rm -f make_eesupp.errors
1016      else      else
1017          echo "Error: problem encountered while building source files in eesupp:"          echo "Error: problem encountered while building source files in eesupp:"
1018          cat make_eesupp.errors          cat make_eesupp.errors 1>&2
1019          exit 1          exit 1
1020      fi      fi
1021  fi  fi
1022    
1023    #same for exch2
1024    if test -r $ROOTDIR"/pkg/exch2/Makefile" ; then
1025        echo "  Making source files in exch2 from  templates"
1026        ( cd $ROOTDIR"/pkg/exch2/" && $MAKE ) > make_exch2.errors 2>&1
1027        RETVAL=$?
1028        if test "x${RETVAL}" = x0 ; then
1029            rm -f make_exch2.errors
1030        else
1031            echo "Error: problem encountered while building source files in exch2:"
1032            cat make_exch2.errors 1>&2
1033            exit 1
1034        fi
1035    fi
1036    
1037  printf "\n===  Determining package settings  ===\n"  printf "\n===  Determining package settings  ===\n"
1038  if  test "x${PDEPEND}" = x ; then  if  test "x${PDEPEND}" = x ; then
1039      tmp=$ROOTDIR"/pkg/pkg_depend"      tmp=$ROOTDIR"/pkg/pkg_depend"
# Line 960  rm -f ./.pd_tmp Line 1066  rm -f ./.pd_tmp
1066  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"  #  Search for default packages.  Note that a "$ROOTDIR/pkg/pkg_groups"
1067  #  file should eventually be added so that, for convenience, one can  #  file should eventually be added so that, for convenience, one can
1068  #  specify groups of packages using names like "ocean" and "atmosphere".  #  specify groups of packages using names like "ocean" and "atmosphere".
1069  echo  -n "  checking default package list:  "  echo "  checking default package list:  "
1070  if test "x${PDEFAULT}" = x ; then  if test "x${PDEFAULT}" = x ; then
1071      for i in "." $MODS ; do      for i in "." $MODS ; do
1072          if test -r $i"/packages.conf" ; then          if test -r $i"/packages.conf" ; then
# Line 973  if test "x${PDEFAULT}" = x ; then Line 1079  if test "x${PDEFAULT}" = x ; then
1079      PDEFAULT="$ROOTDIR/pkg/pkg_default"      PDEFAULT="$ROOTDIR/pkg/pkg_default"
1080  fi  fi
1081  if test "x${PDEFAULT}" = xNONE ; then  if test "x${PDEFAULT}" = xNONE ; then
1082      echo "default packages file disabled"      echo "    default packages file disabled"
1083  else  else
1084      if test ! -r $PDEFAULT ; then      if test ! -r $PDEFAULT ; then
         echo ""  
1085          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""          echo "Warning:  can't read default packages from PDEFAULT=\"$PDEFAULT\""
1086      else      else
1087          echo "  using PDEFAULT=\"$PDEFAULT\""          echo "    using PDEFAULT=\"$PDEFAULT\""
1088          #  Strip the comments and add all the names          #  Strip the comments and add all the names
1089          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`          def=`cat $PDEFAULT | sed -e 's/#.*$//g' | $AWK '(NF>0){print $0}'`
1090          RETVAL=$?          RETVAL=$?
# Line 1112  for i in $PACKAGES ; do Line 1217  for i in $PACKAGES ; do
1217      fi      fi
1218  done  done
1219    
1220    #  Build MNC templates and check for ability to build and use NetCDF
1221    echo $PACKAGES | grep ' mnc ' > /dev/null 2>&1
1222    RETVAL=$?
1223    if test "x$RETVAL" = x0 ; then
1224        ( cd $ROOTDIR"/pkg/mnc" && $MAKE templates ) > make_mnc.errors 2>&1
1225        RETVAL=$?
1226        if test "x${RETVAL}" = x0 ; then
1227            rm -f make_mnc.errors
1228        else
1229            echo "Error: problem encountered while building source files in pkg/mnc:"
1230            cat make_mnc.errors 1>&2
1231            exit 1
1232        fi
1233        if test "x$HAVE_NETCDF" != xt ; then
1234            cat <<EOF
1235    
1236  # Create a list of #define and #undef to enable/disable packages  WARNING: the "mnc" package has been enabled but tests failed to
1237  PACKAGES_DOT_H=PACKAGES_CONFIG.h    compile and/or execute NetCDF applications.  Please check that:
 cat <<EOF >$PACKAGES_DOT_H".tmp"  
 C=== GENMAKE v2 ===  
 C  The following defines have been set by GENMAKE, so please do not  
 C  edit anything below these comments.  In general, you should  
 C  add or remove packages by re-running genmake with different  
 C  "-enable" and/or "-disable" options.  
   
 #ifndef PACKAGES_H  
 #define PACKAGES_H  
1238    
1239  C  Packages disabled by genmake:    1) NetCDF is installed for your compiler and
1240      2) the LIBS variable (within the 'optfile") specifies the correct
1241           NetCDF library to link against.
1242      
1243  EOF  EOF
1244        fi
1245    fi
1246    
1247    # Create a list of #define and #undef to enable/disable packages
1248    PACKAGES_DOT_H=PACKAGES_CONFIG.h
1249  #  The following UGLY HACK sets multiple "#undef"s and it needs to go  #  The following UGLY HACK sets multiple "#undef"s and it needs to go
1250  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h  #  away.  On 2003-08-12, CNH, JMC, and EH3 agreed that the CPP_OPTIONS.h
1251  #  file would eventually be split up so that all package-related #define  #  file would eventually be split up so that all package-related #define
1252  #  statements could be separated and handled only by genmake.  #  statements could be separated and handled only by genmake.
1253  names=`ls -1 "$ROOTDIR/pkg"`  names=`ls -1 "$ROOTDIR/pkg"`
1254  all_pack=  all_pack=
1255    DISABLED_PACKAGES=
1256  for n in $names ; do  for n in $names ; do
1257      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then      if test -d "$ROOTDIR/pkg/$n" -a "x$n" != xCVS ; then
1258          has_pack="f"          has_pack="f"
# Line 1144  for n in $names ; do Line 1264  for n in $names ; do
1264          done          done
1265          if test "x$has_pack" = xf ; then          if test "x$has_pack" = xf ; then
1266              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`              undef=`echo "ALLOW_$n" | $AWK '{print toupper($0)}'`
1267              echo "#undef $undef" >> $PACKAGES_DOT_H".tmp"              DISABLED_PACKAGES="$DISABLED_PACKAGES -U$undef"
1268          fi          fi
1269      fi      fi
1270  done  done
1271  cat <<EOF >>$PACKAGES_DOT_H".tmp"  ENABLED_PACKAGES=
   
 C  Packages enabled by genmake:  
 EOF  
1272  for i in $PACKAGES ; do  for i in $PACKAGES ; do
1273      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`      def=`echo "ALLOW_$i" | $AWK '{print toupper($0)}'`
1274      echo "#define $def" >> $PACKAGES_DOT_H".tmp"      ENABLED_PACKAGES="$ENABLED_PACKAGES -D$def"
1275  #eh3 DEFINES="$DEFINES -D$def"  #eh3 DEFINES="$DEFINES -D$def"
1276    
1277  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1278      case $i in      case $i in
1279          aim_v23)          aim_v23)
1280              echo "#define   ALLOW_AIM" >> $PACKAGES_DOT_H".tmp"              ENABLED_PACKAGES="$ENABLED_PACKAGES -DALLOW_AIM"
1281              DEFINES="$DEFINES -DALLOW_AIM"              echo "Warning: ALLOW_AIM is set to enable aim_v23."
             echo "Warning: ALLOW_AIM is set to enable aim_v23. This is REALLY ugly Jean-Michel :-)"  
1282              ;;              ;;
1283      esac      esac
1284  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!  #EH3  WARNING :  This is an UGLY HACK that needs to be removed!!!
1285    
1286  done  done
 cat <<EOF >>$PACKAGES_DOT_H".tmp"  
   
 #endif /* PACKAGES_H */  
 EOF  
   
 if test ! -f $PACKAGES_DOT_H ; then  
     mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
 else  
     cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     RETVAL=$?  
     if test "x$RETVAL" = x0 ; then  
         rm -f $PACKAGES_DOT_H".tmp"  
     else  
         mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"  
         mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H  
     fi  
 fi  
1287    
1288  echo "  Adding STANDARDDIRS"  echo "  Adding STANDARDDIRS"
1289  BUILDDIR=${BUILDDIR:-.}  BUILDDIR=${BUILDDIR:-.}
1290  if test "x$STANDARDDIRS" = x ; then  if test "x$STANDARDDIRS" = xUSE_THE_DEFAULT ; then
1291      STANDARDDIRS="eesupp model"      STANDARDDIRS="eesupp model"
1292  fi  fi
1293  for d in $STANDARDDIRS ; do  if test "x$STANDARDDIRS" != x ; then
1294      adr="$ROOTDIR/$d/src"      for d in $STANDARDDIRS ; do
1295      if test ! -d $adr ; then          adr="$ROOTDIR/$d/src"
1296          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1297          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1298          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1299      else              exit 1
1300          SOURCEDIRS="$SOURCEDIRS $adr"          else
1301      fi              SOURCEDIRS="$SOURCEDIRS $adr"
1302      adr="$ROOTDIR/$d/inc"          fi
1303      if test ! -d $adr ; then          adr="$ROOTDIR/$d/inc"
1304          echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""          if test ! -d $adr ; then
1305          echo "  is correct and that you correctly specified the STANDARDDIRS option"              echo "Error:  directory $adr not found -- please check that ROOTDIR=\"$ROOTDIR\""
1306          exit 1              echo "  is correct and that you correctly specified the STANDARDDIRS option"
1307      else              exit 1
1308          INCLUDEDIRS="$INCLUDEDIRS $adr"          else
1309      fi              INCLUDEDIRS="$INCLUDEDIRS $adr"
1310  done          fi
1311        done
1312    fi
1313    
1314  echo "  Searching for CPP_OPTIONS.h in order to warn about the presence"  echo "  Searching for *OPTIONS.h files in order to warn about the presence"
1315  echo "    of \"#define ALLOW_PKGNAME\"-type statements:"  echo "    of \"#define \"-type statements that are no longer allowed:"
1316  CPP_OPTIONS=  CPP_OPTIONS=
1317    CPP_EEOPTIONS=
1318  spaths=". $INCLUDEDIRS"  spaths=". $INCLUDEDIRS"
1319    names=`ls -1 "$ROOTDIR/pkg"`
1320  for i in $spaths ; do  for i in $spaths ; do
1321      try="$i/CPP_OPTIONS.h"      try="$i/CPP_OPTIONS.h"
1322      #  echo -n "    trying $try : "      if test -f $try -a -r $try -a "x$CPP_OPTIONS" = x ; then
     if test -f $try -a -r $try ; then  
1323          echo "    found CPP_OPTIONS=\"$try\""          echo "    found CPP_OPTIONS=\"$try\""
1324          CPP_OPTIONS="$try"          CPP_OPTIONS="$try"
1325          break          # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h
1326            for n in $names ; do
1327                test_for_package_in_cpp_options $CPP_OPTIONS $n
1328            done
1329        fi
1330        try="$i/CPP_EEOPTIONS.h"
1331        if test -f $try -a -r $try -a "x$CPP_EEOPTIONS" = x ; then
1332            echo "    found CPP_EEOPTIONS=\"$try\""
1333            # New safety test: make sure MPI is not determined by CPP_EEOPTIONS.h
1334    #**** not yet enabled ****
1335    #        test_for_mpi_in_cpp_eeoptions $try
1336    #**** not yet enabled ****
1337            CPP_EEOPTIONS="$try"
1338      fi      fi
1339  done  done
1340  if test "x$CPP_OPTIONS" = x ; then  if test "x$CPP_OPTIONS" = x ; then
1341      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"      echo "Error: can't find \"CPP_OPTIONS.h\" in the path list: $spaths"
1342      exit 1      exit 1
1343  fi  fi
 # New safety test: make sure packages are not mentioned in CPP_OPTIONS.h  
 names=`ls -1 "$ROOTDIR/pkg"`  
 for n in $names ; do  
     test_for_package_in_cpp_options $CPP_OPTIONS $n  
 done  
   
1344    
1345  #  Here, we build the list of files to be "run through" the adjoint  #  Here, we build the list of files to be "run through" the adjoint
1346  #  compiler.  #  compiler.
# Line 1247  for i in $SOURCEDIRS ; do Line 1355  for i in $SOURCEDIRS ; do
1355      done      done
1356  done  done
1357    
 cat <<EOF > adjoint_sed  
 s/call adopen(/call adopen ( mythid,\\  
      \&           /g  
 s/call adclose(/call adclose( mythid,\\  
      \&           /g  
 s/call adread(/call adread ( mythid,\\  
      \&           /g  
 s/call adwrite(/call adwrite( mythid,\\  
      \&           /g  
   
 EOF  
1358    
1359  echo  echo
1360  echo "===  Creating the Makefile  ==="  echo "===  Creating the Makefile  ==="
# Line 1288  for d in $alldirs ; do Line 1385  for d in $alldirs ; do
1385      for sf in $sfiles ; do      for sf in $sfiles ; do
1386          if test ! -r ".links.tmp/$sf" ; then          if test ! -r ".links.tmp/$sf" ; then
1387              if test -f "$d/$sf" ; then              if test -f "$d/$sf" ; then
1388                    case $d/$sf in
1389                      ./$PACKAGES_DOT_H)
1390                            ;;
1391                      ./AD_CONFIG.h)
1392                            ;;
1393                      ./FC_NAMEMANGLE.h)
1394                            ;;
1395                      *)
1396                            touch .links.tmp/$sf
1397                            deplist="$deplist $sf"
1398                            ;;
1399                    esac
1400                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`                  extn=`echo $sf | $AWK -F '.' '{print $NF}'`
                 touch .links.tmp/$sf  
                 deplist="$deplist $sf"  
1401                  case $extn in                  case $extn in
1402                      F)                      F)
1403                          echo    " \\"  >> srclist.inc                          echo    " \\"  >> srclist.inc
# Line 1348  EXE_FTL=$EXECUTABLE"_ftl" Line 1455  EXE_FTL=$EXECUTABLE"_ftl"
1455  EXE_SVD=$EXECUTABLE"_svd"  EXE_SVD=$EXECUTABLE"_svd"
1456    
1457  cat >>$MAKEFILE <<EOF  cat >>$MAKEFILE <<EOF
1458    #
1459    # OPTFILE="$OPTFILE"
1460  #  #
1461  # BUILDDIR     : Directory where object files are written  # BUILDDIR     : Directory where object files are written
1462  # SOURCEDIRS   : Directories containing the source (.F) files  # SOURCEDIRS   : Directories containing the source (.F) files
# Line 1381  EXE_AD      = ${EXE_AD} Line 1490  EXE_AD      = ${EXE_AD}
1490  EXE_FTL     = ${EXE_FTL}  EXE_FTL     = ${EXE_FTL}
1491  EXE_SVD     = ${EXE_SVD}  EXE_SVD     = ${EXE_SVD}
1492    
1493    ENABLED_PACKAGES = ${ENABLED_PACKAGES}
1494    DISABLED_PACKAGES = ${DISABLED_PACKAGES}
1495    
1496    # These files are created by Makefile
1497    SPECIAL_FILES = ${PACKAGES_DOT_H} AD_CONFIG.h FC_NAMEMANGLE.h
1498    
1499  EOF  EOF
1500    
1501  #  Note: figure out some way to add Hyades JAM libraries here  #  Note: figure out some way to add Hyades JAM libraries here
# Line 1445  cat >>$MAKEFILE <<EOF Line 1560  cat >>$MAKEFILE <<EOF
1560  .SUFFIXES: .o .f .p .F .c .F90 .f90  .SUFFIXES: .o .f .p .F .c .F90 .f90
1561    
1562  all: \$(EXECUTABLE)  all: \$(EXECUTABLE)
1563  \$(EXECUTABLE): \$(OBJFILES)  \$(EXECUTABLE): \$(SPECIAL_FILES) \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(OBJFILES)
1564            @echo Creating \$@ ...
1565          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)          \$(LINK) -o \$@ \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) \$(LIBS)
1566  depend:  depend:
1567          @make links          @make links
1568          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)          \$(MAKEDEPEND) -o .f \$(DEFINES) \$(INCLUDES) \$(SRCFILES)
1569          ${TOOLSDIR}/f90mkdepend >> \$(MAKEFILE)          \$(TOOLSDIR)/f90mkdepend >> \$(MAKEFILE)
1570    
1571  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES)  links: \$(SRCFILES) \$(CSRCFILES) \$(HEADERFILES) \$(F90SRCFILES) \$(SPECIAL_FILES)
1572    
1573  small_f: \$(F77FILES) \$(F90FILES)  small_f: \$(F77FILES) \$(F90FILES)
1574    
# Line 1461  output.txt: \$(EXECUTABLE) Line 1577  output.txt: \$(EXECUTABLE)
1577          @\$(EXECUTABLE) > \$@          @\$(EXECUTABLE) > \$@
1578    
1579  clean:  clean:
1580          -cat AD_CONFIG.template > AD_CONFIG.h          -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl} *.template
         -rm -rf *.o *.f *.p *.f90 *.mod ${RMFILES} work.{pc,pcl}  
1581  Clean:  Clean:
1582          @make clean          @make clean
1583          @make cleanlinks          @make cleanlinks
1584          -rm -f Makefile.bak genmake_state genmake_*optfile make.log          -rm -f \$(SPECIAL_FILES)
1585            -rm -f genmake_state genmake_*optfile genmake_warnings make.log run.log *.bak
1586  CLEAN:  CLEAN:
1587          @make Clean          @make Clean
1588          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;          -find \$(EXEDIR) -name "*.meta" -exec rm {} \;
# Line 1476  CLEAN: Line 1592  CLEAN:
1592    
1593  #eh3 Makefile: makefile  #eh3 Makefile: makefile
1594  makefile:  makefile:
1595          ${0} $@          $THIS_SCRIPT $@
1596  cleanlinks:  cleanlinks:
1597          -find . -type l -exec rm {} \;          -find . -type l -exec rm {} \;
1598    
1599    # Special targets ($SPECIAL_FILES) which are create by make
1600    ${PACKAGES_DOT_H}:
1601            @echo Creating \$@ ...
1602            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" \$(DISABLED_PACKAGES) " " "Enabled packages:" \$(ENABLED_PACKAGES) > \$@
1603    AD_CONFIG.h:
1604            @echo Creating \$@ ...
1605            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bAD_CONFIG_H -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > \$@
1606    FC_NAMEMANGLE.h:
1607            @echo Creating \$@ ...
1608            echo "$FC_NAMEMANGLE" > \$@
1609    
1610  # The normal chain of rules is (  .F - .f - .o  )  # The normal chain of rules is (  .F - .f - .o  )
1611  .F.f:  .F.f:
1612          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@          \$(CPP) \$(DEFINES) \$(INCLUDES) > \$@
# Line 1539  adtaf: ad_taf_output.f Line 1666  adtaf: ad_taf_output.f
1666  adtamc: ad_tamc_output.f  adtamc: ad_tamc_output.f
1667    
1668  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ad_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1669            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -DALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ad_config.template
1670          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h          cmp ad_config.template AD_CONFIG.h || cat ad_config.template > AD_CONFIG.h
1671            -rm -f ad_config.template
1672          @make \$(F77FILES)          @make \$(F77FILES)
1673          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1674          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ad_input_code.f
1675    
1676  ad_taf_output.f: ad_input_code.f  ad_taf_output.f: ad_input_code.f
1677          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1678          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1679    
1680  adtafonly:  adtafonly:
1681          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f          \$(TAF) \$(AD_TAF_FLAGS) \$(TAF_EXTRA) ad_input_code.f
1682          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_taf_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_taf_output.f
1683    
1684  ad_taf: ad_taf_output.o \$(OBJFILES)  ad_taf: ad_taf_output.o \$(OBJFILES)
1685          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o \$(LIBS)
1686    
1687  ad_tamc_output.f: ad_input_code.f  ad_tamc_output.f: ad_input_code.f
1688          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f          \$(TAMC) \$(AD_TAMC_FLAGS) \$(TAMC_EXTRA) ad_input_code.f
1689          cat ad_input_code_ad.f | sed -f adjoint_sed > ad_tamc_output.f          cat ad_input_code_ad.f | sed -f \$(TOOLSDIR)/adjoint_sed > ad_tamc_output.f
1690    
1691  ad_tamc: ad_tamc_output.o \$(OBJFILES)  ad_tamc: ad_tamc_output.o \$(OBJFILES)
1692          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_AD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_tamc_output.o \$(LIBS)
# Line 1569  ftltaf: ftl_taf_output.f Line 1698  ftltaf: ftl_taf_output.f
1698  ftltamc: ftl_tamc_output.f  ftltamc: ftl_tamc_output.f
1699    
1700  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)  ftl_input_code.f: \$(AD_FILES) \$(HEADERFILES)
1701            @\$(TOOLSDIR)/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -DALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > ftl_config.template
1702          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h          cmp ftl_config.template AD_CONFIG.h || cat ftl_config.template > AD_CONFIG.h
1703            -rm -f ftl_config.template
1704          @make \$(F77FILES)          @make \$(F77FILES)
1705          @make \$(AD_FLOW_FILES)          @make \$(AD_FLOW_FILES)
1706          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f          cat \$(AD_FLOW_FILES) \$(AD_FILES) > ftl_input_code.f
1707    
1708  ftl_taf_output.f: ftl_input_code.f  ftl_taf_output.f: ftl_input_code.f
1709          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f          \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1710          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_taf_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1711    
1712    ftltafonly:
1713            \$(TAF) \$(FTL_TAF_FLAGS) \$(TAF_EXTRA) ftl_input_code.f
1714            cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_taf_output.f
1715    
1716  ftl_taf: ftl_taf_output.o \$(OBJFILES)  ftl_taf: ftl_taf_output.o \$(OBJFILES)
1717          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_taf_output.o \$(LIBS)
1718    
1719  ftl_tamc_output.f: ftl_input_code.f  ftl_tamc_output.f: ftl_input_code.f
1720          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f          \$(TAMC) \$(FTL_TAMC_FLAGS) \$(TAMC_EXTRA) ftl_input_code.f
1721          cat ftl_input_code_ftl.f | sed -f adjoint_sed > ftl_tamc_output.f          cat ftl_input_code_ftl.f | sed -f \$(TOOLSDIR)/adjoint_sed > ftl_tamc_output.f
1722    
1723  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)  ftl_tamc: ftl_tamc_output.o \$(OBJFILES)
1724          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)          \$(LINK) -o ${EXE_FTL} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ftl_tamc_output.o \$(LIBS)
1725    
1726    
1727  # ... SVD ...  # ... SVD ...
1728  svd: svd_taf  svdtaf: ad_taf_output.f ftl_taf_output.f
1729  svd_taf_f: svd_taf_output.f  svdall: svd_taf
   
 svd_input_code.f: \$(SRCFILES)  
         cmp svd_config.template AD_CONFIG.h || cat svd_config.template > AD_CONFIG.h  
         @make \$(F77FILES)  
         @make \$(AD_FLOW_FILES)  
         cat \$(AD_FLOW_FILES) \$(AD_FILES) > svd_input_code.f  
   
 svd_taf_output.f: svd_input_code.f  
         \$(TAF) \$(SVD_TAF_FLAGS) \$(TAF_EXTRA) svd_input_code.f  
         cat svd_input_code_ad.f | sed -f adjoint_sed > svd_taf_output.f  
1730    
1731  svd_taf: svd_taf_output.o \$(OBJFILES)  svd_taf: ad_taf_output.o ftl_taf_output.o \$(OBJFILES)
1732          \$(LINK) -o ${EXE_SVD} \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) svd_taf_output.o \$(LIBS)          \$(LINK) -o mitgcmuv_svd \$(FFLAGS) \$(FOPTIM) \$(OBJFILES) ad_taf_output.o ftl_taf_output.o \$(LIBS)
1733    
1734    
1735  #=========================================  #=========================================
# Line 1645  printf "\n\n# DO NOT DELETE\n" >> $MAKEF Line 1770  printf "\n\n# DO NOT DELETE\n" >> $MAKEF
1770    
1771  printf "\n===  Done  ===\n"  printf "\n===  Done  ===\n"
1772    
1773  #  Write the "template" files for the adjoint builds  # Create special header files
1774  cat >AD_CONFIG.template <<EOF  $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -bPACKAGES_CONFIG_H "Disabled packages:" $DISABLED_PACKAGES " " "Enabled packages:" $ENABLED_PACKAGES > $PACKAGES_DOT_H".tmp"
1775  C  WARNING: This file is automatically generated by genmake2 and  if test ! -f $PACKAGES_DOT_H ; then
1776  C    used by the Makefile rules.  Please DO NOT EDIT this file      mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1777  C    unless you are CERTAIN that you know what you are doing.  else
1778        cmp $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H > /dev/null 2>&1
1779  #undef ALLOW_ADJOINT_RUN      RETVAL=$?
1780  #undef ALLOW_TANGENTLINEAR_RUN      if test "x$RETVAL" = x0 ; then
1781  #undef ALLOW_ECCO_OPTIMIZATION          rm -f $PACKAGES_DOT_H".tmp"
1782  EOF      else
1783  cat >ad_config.template <<EOF          mv -f $PACKAGES_DOT_H $PACKAGES_DOT_H".bak"
1784  C  WARNING: This file is automatically generated by genmake2 and          mv -f $PACKAGES_DOT_H".tmp" $PACKAGES_DOT_H
1785  C    used by the Makefile rules.  Please DO NOT EDIT this file      fi
1786  C    unless you are CERTAIN that you know what you are doing.  fi
1787    if test ! -f AD_CONFIG.h ; then
1788  #define ALLOW_ADJOINT_RUN      $TOOLSDIR/convert_cpp_cmd2defines "Warning - this file is automatically generated - do NOT edit" -UALLOW_ADJOINT_RUN -UALLOW_TANGENTLINEAR_RUN -UALLOW_ECCO_OPTIMIZATION > AD_CONFIG.h
1789  #undef ALLOW_TANGENTLINEAR_RUN  fi
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >ftl_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #define ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cat >svd_config.template <<EOF  
 C  WARNING: This file is automatically generated by genmake2 and  
 C    used by the Makefile rules.  Please DO NOT EDIT this file  
 C    unless you are CERTAIN that you know what you are doing.  
   
 #undef ALLOW_ADJOINT_RUN  
 #undef ALLOW_TANGENTLINEAR_RUN  
 #undef ALLOW_ECCO_OPTIMIZATION  
 EOF  
 cp AD_CONFIG.template AD_CONFIG.h  
1790    
1791    
1792  #  Write the "state" for future records  #  Write the "state" for future records

Legend:
Removed from v.1.39  
changed lines
  Added in v.1.66

  ViewVC Help
Powered by ViewVC 1.1.22